# -*- coding: utf-8 -*-

import location

stations = [{'name':"Aachen Hbf", 'lat': 50.767828, 'lng': 6.092249 }, {'name':"Aachen West", 'lat': 50.7765852, 'lng': 6.0836128 }, {'name':"Aalten", 'lat': 51.9269782, 'lng': 6.5814828 }, {'name':"Abcoude", 'lat': 52.2724537, 'lng': 4.9746945 }, {'name':"Ahaus", 'lat': 52.0766382, 'lng': 7.0082105 }, {'name':"Aime la Plagne", 'lat': None, 'lng': None }, {'name':"Akkrum", 'lat': 53.0487916, 'lng': 5.8351321 }, {'name':"Albertville", 'lat': 34.2675937, 'lng': -86.2088669 }, {'name':"Alkmaar", 'lat': 52.6323558, 'lng': 4.7506779 }, {'name':"Alkmaar Noord", 'lat': 52.67069, 'lng': 4.82455 }, {'name':"Almelo", 'lat': 52.3576027, 'lng': 6.6637611 }, {'name':"Almelo de Riet", 'lat': 52.3465361, 'lng': 6.6685611 }, {'name':"Almere", 'lat': 52.3722064, 'lng': 5.2180223 }, {'name':"Almere Buiten", 'lat': 52.39437, 'lng': 5.27827 }, {'name':"Almere Centrum", 'lat': 52.37503, 'lng': 5.21764 }, {'name':"Almere Muziekwijk", 'lat': 52.36761, 'lng': 5.1906 }, {'name':"Almere Oostvaarders", 'lat': 52.3957615, 'lng': 5.265967 }, {'name':"Almere Parkwijk", 'lat': 52.3749884, 'lng': 5.2451763 }, {'name':"Alphen a/d Rijn", 'lat': 52.1285566, 'lng': 4.6580531 }, {'name':"Altenberge", 'lat': 52.045757, 'lng': 7.4654436 }, {'name':"Amersfoort", 'lat': 52.1565886, 'lng': 5.3889173 }, {'name':"Amersfoort Schothorst", 'lat': 52.1792182, 'lng': 5.3848383 }, {'name':"Amersfoort Vathorst", 'lat': 52.1974, 'lng': 5.4123111 }, {'name':"Amsterdam", 'lat': 52.3738007, 'lng': 4.8909347 }, {'name':"Amsterdam Amstel", 'lat': 52.3339282, 'lng': 4.904913 }, {'name':"Amsterdam Bijlmer ArenA", 'lat': 52.31157, 'lng': 4.94741 }, {'name':"Amsterdam Centraal", 'lat': 52.37851, 'lng': 4.9005 }, {'name':"Amsterdam Holendrecht", 'lat': 52.29811, 'lng': 4.95976 }, {'name':"Amsterdam Lelylaan", 'lat': 52.35713, 'lng': 4.83418 }, {'name':"Amsterdam Muiderpoort", 'lat': 52.3636111, 'lng': 4.9197222 }, {'name':"Amsterdam RAI", 'lat': 52.33732, 'lng': 4.88948 }, {'name':"Amsterdam Science Park", 'lat': 52.3547493, 'lng': 4.9571898 }, {'name':"Amsterdam Sloterdijk", 'lat': 52.38897, 'lng': 4.83887 }, {'name':"Amsterdam Zuid", 'lat': 52.3392, 'lng': 4.87408 }, {'name':"Angermuende", 'lat': 53.0158946, 'lng': 14.0002545 }, {'name':"Anna Paulowna", 'lat': 52.861971, 'lng': 4.8339834 }, {'name':"Antwerpen Centraal", 'lat': 51.2172702, 'lng': 4.4206487 }, {'name':"Apeldoorn", 'lat': 52.2162805, 'lng': 5.9646373 }, {'name':"Apeldoorn De Maten", 'lat': 52.20527, 'lng': 6.00068 }, {'name':"Apeldoorn Osseveld", 'lat': 52.2155838, 'lng': 6.0023283 }, {'name':"Appingedam", 'lat': 53.3202659, 'lng': 6.8575082 }, {'name':"Arkel", 'lat': 51.87221, 'lng': 4.99295 }, {'name':"Arnemuiden", 'lat': 51.4996012, 'lng': 3.6736488 }, {'name':"Arnhem", 'lat': 51.9797296, 'lng': 5.9124034 }, {'name':"Arnhem Presikhaaf", 'lat': 51.9824936, 'lng': 5.9459146 }, {'name':"Arnhem Velperpoort", 'lat': None, 'lng': None }, {'name':"Arnhem Zuid", 'lat': 51.95483, 'lng': 5.85193 }, {'name':"Assen", 'lat': 52.9945984, 'lng': 6.5595076 }, {'name':"Augsburg Hbf", 'lat': 48.3653737, 'lng': 10.8885026 }, {'name':"Avignon TGV", 'lat': 43.9306506, 'lng': 4.7647572 }, {'name':"Baarn", 'lat': 52.212037, 'lng': 5.2926822 }, {'name':"Bad Bentheim", 'lat': 52.3017868, 'lng': 7.1594285 }, {'name':"Baden", 'lat': 47.476433, 'lng': 8.3076929 }, {'name':"Baden Baden", 'lat': 48.7598004, 'lng': 8.2397925 }, {'name':"Baflo", 'lat': 53.3616985, 'lng': 6.51441 }, {'name':"Barendrecht", 'lat': 51.8529759, 'lng': 4.5367869 }, {'name':"Barneveld Centrum", 'lat': 52.18725, 'lng': 5.77182 }, {'name':"Barneveld Noord", 'lat': 52.16085, 'lng': 5.59895 }, {'name':"Basel Bad Bf", 'lat': 47.5681638, 'lng': 7.6072963 }, {'name':"Basel SBB", 'lat': 47.5474211, 'lng': 7.5895635 }, {'name':"Bedum", 'lat': 53.3009378, 'lng': 6.6009713 }, {'name':"Beek Elsloo", 'lat': 50.9474321, 'lng': 5.7743562 }, {'name':"Beesd", 'lat': 51.8858284, 'lng': 5.1945828 }, {'name':"Beilen", 'lat': 52.85485, 'lng': 6.52093 }, {'name':"Bergen op Zoom", 'lat': 51.4941031, 'lng': 4.2878432 }, {'name':"Berlin Hbf. Lehrter Bahnhof", 'lat': 52.5234051, 'lng': 13.4113999 }, {'name':"Berlin Ostbahnhof", 'lat': 52.5234051, 'lng': 13.4113999 }, {'name':"Berlin Gesundbrunnen", 'lat': 52.5333333, 'lng': 13.3833333 }, {'name':"Berlin Sch�nefeld Flughafen", 'lat': None, 'lng': None }, {'name':"Berlin Spandau", 'lat': 52.534072, 'lng': 13.181689 }, {'name':"Bernau (B Berlin)", 'lat': 52.68087, 'lng': 13.58363 }, {'name':"Best", 'lat': 40.7250951, 'lng': -75.6560209 }, {'name':"Beverwijk", 'lat': 52.4857719, 'lng': 4.6581525 }, {'name':"Bilthoven", 'lat': 52.1301, 'lng': 5.20494 }, {'name':"Blerick", 'lat': 51.3628549, 'lng': 6.148013 }, {'name':"Bloemendaal", 'lat': 52.4055944, 'lng': 4.6226598 }, {'name':"Bodegraven", 'lat': 52.0842843, 'lng': 4.7468801 }, {'name':"Boenen", 'lat': 51.5981868, 'lng': 7.7772133 }, {'name':"Boisheim", 'lat': 51.271366, 'lng': 6.271868 }, {'name':"Bonn Hbf", 'lat': 50.7327045, 'lng': 7.0963113 }, {'name':"Borghorst (Westf)", 'lat': None, 'lng': None }, {'name':"Bork (Westf)", 'lat': 51.669883, 'lng': 7.456636 }, {'name':"Borne", 'lat': 52.29806, 'lng': 6.74909 }, {'name':"Boskoop", 'lat': 52.074767, 'lng': 4.65878 }, {'name':"Bourg St Maurice", 'lat': 45.6169507, 'lng': 6.7670769 }, {'name':"Bovenkarspel Flora", 'lat': 52.69619, 'lng': 5.25299 }, {'name':"Bovenkarspel Grootebroek", 'lat': 52.6958064, 'lng': 5.2350099 }, {'name':"Boxmeer", 'lat': 51.6488083, 'lng': 5.9478845 }, {'name':"Boxtel", 'lat': 51.5884671, 'lng': 5.3263468 }, {'name':"Breda", 'lat': 51.5893217, 'lng': 4.7744913 }, {'name':"Breda Prinsenbeek", 'lat': None, 'lng': None }, {'name':"Bremen Hbf", 'lat': 53.074981, 'lng': 8.807081 }, {'name':"Bressoux", 'lat': 50.6438917, 'lng': 5.6119104 }, {'name':"Breukelen", 'lat': 52.1707743, 'lng': 5.0029723 }, {'name':"Breyell", 'lat': 51.295396, 'lng': 6.239922 }, {'name':"Brummen", 'lat': 52.0879239, 'lng': 6.15713 }, {'name':"Brussel Centraal", 'lat': 50.8456035, 'lng': 4.3568658 }, {'name':"Brussel Noord", 'lat': 50.8604931, 'lng': 4.3607035 }, {'name':"Brussel Zuid/Midi", 'lat': 50.8348278, 'lng': 4.3365303 }, {'name':"Buitenpost", 'lat': 53.2520834, 'lng': 6.1447785 }, {'name':"Bunde", 'lat': 52.195807, 'lng': 8.581551 }, {'name':"Bunnik", 'lat': 52.0673852, 'lng': 5.2008909 }, {'name':"Burgsteinfurt", 'lat': 52.151015, 'lng': 7.335603 }, {'name':"Bussum Zuid", 'lat': 52.26597, 'lng': 5.16294 }, {'name':"Capelle Schollevaar", 'lat': 51.95429, 'lng': 4.58394 }, {'name':"Castricum", 'lat': 52.5465396, 'lng': 4.6623276 }, {'name':"Chambery", 'lat': 45.5667045, 'lng': 5.9209874 }, {'name':"Chevremont", 'lat': 50.87605, 'lng': 6.05983 }, {'name':"Coesfeld (Westf)", 'lat': 51.939022, 'lng': 7.164202 }, {'name':"Coevorden", 'lat': 52.6613864, 'lng': 6.7417896 }, {'name':"Cuijk", 'lat': 51.7294157, 'lng': 5.8788147 }, {'name':"Culemborg", 'lat': 51.9575444, 'lng': 5.2257838 }, {'name':"Daarlerveen", 'lat': 52.4423456, 'lng': 6.5786728 }, {'name':"Dalen", 'lat': 48.9458565, 'lng': -100.519613 }, {'name':"Dalfsen", 'lat': 52.5068841, 'lng': 6.2608944 }, {'name':"De Eschmarke", 'lat': 52.2150255, 'lng': 6.9504951 }, {'name':"De Vink", 'lat': 52.14697, 'lng': 4.45617 }, {'name':"Deinum", 'lat': 53.18963, 'lng': 5.72878 }, {'name':"Delden", 'lat': 52.2626571, 'lng': 6.7123089 }, {'name':"Delft", 'lat': 52.0118994, 'lng': 4.3602566 }, {'name':"Delft Zuid", 'lat': 51.99094, 'lng': 4.3647 }, {'name':"Delfzijl", 'lat': 53.3334678, 'lng': 6.9267189 }, {'name':"Delfzijl West", 'lat': 53.33197, 'lng': 6.90692 }, {'name':"Den Bosch", 'lat': 51.6900886, 'lng': 5.3036905 }, {'name':"Den Bosch Oost", 'lat': 51.70053, 'lng': 5.31906 }, {'name':"Den Dolder", 'lat': 52.1398403, 'lng': 5.2415723 }, {'name':"Den Haag", 'lat': 52.0782886, 'lng': 4.313685 }, {'name':"Den Haag Centraal", 'lat': 52.08108, 'lng': 4.32368 }, {'name':"Den Haag HS", 'lat': 52.07, 'lng': 4.32191 }, {'name':"Den Haag Laan v NOI", 'lat': 52.07933, 'lng': 4.34399 }, {'name':"Den Haag Mariahoeve", 'lat': 52.09094, 'lng': 4.36933 }, {'name':"Den Haag Moerwijk", 'lat': 52.05471, 'lng': 4.30856 }, {'name':"Den Haag Ypenburg", 'lat': 52.040001, 'lng': 4.37 }, {'name':"Den Helder", 'lat': 52.9573758, 'lng': 4.7585038 }, {'name':"Den Helder Zuid", 'lat': 52.93304, 'lng': 4.76392 }, {'name':"Deurne", 'lat': 51.4662211, 'lng': 5.7948622 }, {'name':"Deventer", 'lat': 52.25709, 'lng': 6.16082 }, {'name':"Deventer Colmschate", 'lat': 52.2485897, 'lng': 6.2182163 }, {'name':"Deventer De Scheg", 'lat': 52.2494811, 'lng': 6.2142909 }, {'name':"Didam", 'lat': 51.9428774, 'lng': 6.1290286 }, {'name':"Diemen", 'lat': 52.3410068, 'lng': 4.9633504 }, {'name':"Diemen Zuid", 'lat': 52.3303, 'lng': 4.95646 }, {'name':"Dieren", 'lat': 52.04408, 'lng': 6.10249 }, {'name':"Doetinchem", 'lat': 51.9649931, 'lng': 6.2876422 }, {'name':"Doetinchem De Huet", 'lat': 51.9593, 'lng': 6.25971 }, {'name':"Dordrecht", 'lat': 51.8112956, 'lng': 4.6678228 }, {'name':"Dordrecht Stadspolders", 'lat': 51.8019, 'lng': 4.71688 }, {'name':"Dordrecht Zuid", 'lat': 51.79023, 'lng': 4.67154 }, {'name':"Dortmund Hbf", 'lat': 51.5120542, 'lng': 7.4635729 }, {'name':"Dortmund Derne", 'lat': 51.569288, 'lng': 7.51961 }, {'name':"Dortmund Kirchderne", 'lat': 51.556153, 'lng': 7.511472 }, {'name':"Driebergen Zeist", 'lat': 52.0819874, 'lng': 5.2386719 }, {'name':"Driehuis", 'lat': 52.443, 'lng': 4.63912 }, {'name':"Dronrijp", 'lat': 53.1905969, 'lng': 5.6420014 }, {'name':"Duelken", 'lat': 51.256985, 'lng': 6.338627 }, {'name':"Duelmen", 'lat': 51.8285852, 'lng': 7.2778367 }, {'name':"Duesseldorf Hbf", 'lat': 51.204, 'lng': 6.684 }, {'name':"Duisburg Hbf", 'lat': 51.4351266, 'lng': 6.7624346 }, {'name':"Duiven", 'lat': 51.9499007, 'lng': 6.0243744 }, {'name':"Duivendrecht", 'lat': 52.3322956, 'lng': 4.9393846 }, {'name':"Eberswalde Hbf", 'lat': 52.834461, 'lng': 13.79754 }, {'name':"Echt", 'lat': 51.0611183, 'lng': 5.8499587 }, {'name':"Ede Centrum", 'lat': 52.12716, 'lng': 5.75587 }, {'name':"Ede Wageningen", 'lat': 52.02789, 'lng': 5.67172 }, {'name':"Eijsden", 'lat': 50.7784982, 'lng': 5.7124223 }, {'name':"Eindhoven", 'lat': 51.4365957, 'lng': 5.4780014 }, {'name':"Eindhoven Beukenlaan", 'lat': 51.4439554, 'lng': 5.4491781 }, {'name':"Ekeren", 'lat': 51.2771364, 'lng': 4.4182646 }, {'name':"Elst", 'lat': 51.91699, 'lng': 5.85477 }, {'name':"Emmen", 'lat': 52.7877012, 'lng': 6.8948125 }, {'name':"Emmen Bargeres", 'lat': 52.7666667, 'lng': 6.8666667 }, {'name':"Emmerich", 'lat': 45.0908007, 'lng': -89.8292952 }, {'name':"Enkhuizen", 'lat': 52.69959, 'lng': 5.28765 }, {'name':"Ennepetal (Gevelsberg)", 'lat': 51.30445, 'lng': 7.343243 }, {'name':"Enschede", 'lat': 52.2208187, 'lng': 6.8911401 }, {'name':"Enschede Drienerlo", 'lat': 52.23711, 'lng': 6.83913 }, {'name':"Epe (Westf)", 'lat': 52.183398, 'lng': 7.030016 }, {'name':"Ermelo", 'lat': None, 'lng': None }, {'name':"Essen (Belgie)", 'lat': 51.4646676, 'lng': 4.4513476 }, {'name':"Etten Leur", 'lat': 51.5695828, 'lng': 4.6357703 }, {'name':"Eygelshoven", 'lat': 50.8936691, 'lng': 6.0606126 }, {'name':"Eygelshoven Markt", 'lat': 50.89418, 'lng': 6.05975 }, {'name':"Franeker", 'lat': 53.1877067, 'lng': 5.5400198 }, {'name':"Frankfurt (M) Hbf", 'lat': 50.1074452, 'lng': 8.6647471 }, {'name':"Frankfurt Flughafen Fernbf", 'lat': 50.053167, 'lng': 8.570185 }, {'name':"Freiburg (Breisgau) Hbf", 'lat': 47.997887, 'lng': 7.84134 }, {'name':"Gaanderen", 'lat': 51.9289584, 'lng': 6.3441226 }, {'name':"Geerdijk", 'lat': 52.47542, 'lng': 6.5663 }, {'name':"Geislingen", 'lat': 48.6247859, 'lng': 9.8270421 }, {'name':"Geldermalsen", 'lat': 51.8832291, 'lng': 5.2884165 }, {'name':"Geldrop", 'lat': 51.4221676, 'lng': 5.5571129 }, {'name':"Geleen Oost", 'lat': 50.96716, 'lng': 5.84264 }, {'name':"Geleen Lutterade", 'lat': 50.9783333, 'lng': 5.8236111 }, {'name':"Gilze Rijen", 'lat': 51.5883183, 'lng': 4.919438 }, {'name':"Glanerbrug", 'lat': 52.215116, 'lng': 6.9742656 }, {'name':"Goeppingen", 'lat': 48.703158, 'lng': 9.653999 }, {'name':"Goes", 'lat': 39.7667264, 'lng': -83.9160414 }, {'name':"Goor", 'lat': 53.28319, 'lng': 5.58918 }, {'name':"Gorinchem", 'lat': 51.8364091, 'lng': 4.9727679 }, {'name':"Gouda", 'lat': 52.0102707, 'lng': 4.7098329 }, {'name':"Gouda Goverwelle", 'lat': 52.01, 'lng': 4.7444444 }, {'name':"Gramsbergen", 'lat': 52.60994, 'lng': 6.67612 }, {'name':"Grijpskerk", 'lat': 53.2640421, 'lng': 6.3061948 }, {'name':"Gronau Westf", 'lat': 52.21521, 'lng': 7.022109 }, {'name':"Groningen", 'lat': 53.2148825, 'lng': 6.5677579 }, {'name':"Groningen Europapark", 'lat': 53.20841, 'lng': 6.59191 }, {'name':"Groningen Noord", 'lat': None, 'lng': None }, {'name':"Grou Jirnsum", 'lat': 53.09007, 'lng': 5.82233 }, {'name':"G�nzburg", 'lat': None, 'lng': None }, {'name':"Haarlem", 'lat': 52.3794934, 'lng': 4.6377184 }, {'name':"Haarlem Spaarnwoude", 'lat': 52.38806, 'lng': 4.63845 }, {'name':"Hagen Hbf", 'lat': 51.361621, 'lng': 7.459367 }, {'name':"Hamburg Hbf", 'lat': 53.552736, 'lng': 10.006909 }, {'name':"Hamm (Westf.)", 'lat': 51.678078, 'lng': 7.807821 }, {'name':"Hannover Hbf", 'lat': 52.3720683, 'lng': 9.7356861 }, {'name':"Harde ('t)", 'lat': 52.40901, 'lng': 5.89229 }, {'name':"Hardenberg", 'lat': 52.5752572, 'lng': 6.6151896 }, {'name':"Harderwijk", 'lat': 52.3513932, 'lng': 5.6201141 }, {'name':"Hardinxveld Giessendam", 'lat': 51.8225175, 'lng': 4.8824754 }, {'name':"Haren", 'lat': 53.173179, 'lng': 6.6029495 }, {'name':"Harlingen", 'lat': 26.1906306, 'lng': -97.6961026 }, {'name':"Harlingen Haven", 'lat': 53.1747222, 'lng': 5.4111111 }, {'name':"Heemskerk", 'lat': 52.5119516, 'lng': 4.6743604 }, {'name':"Heemstede Aerdenhout", 'lat': 52.3668027, 'lng': 4.593047 }, {'name':"Heerenveen", 'lat': 52.9565294, 'lng': 5.9262187 }, {'name':"Heerenveen IJsstadion", 'lat': 52.9355556, 'lng': 5.9438889 }, {'name':"Heerhugowaard", 'lat': 52.6695404, 'lng': 4.8471904 }, {'name':"Heerlen", 'lat': 50.8830398, 'lng': 5.9809352 }, {'name':"Heerlen De Kissel", 'lat': 50.89072, 'lng': 5.99634 }, {'name':"Heeze", 'lat': 51.3498291, 'lng': 5.5521943 }, {'name':"Heide", 'lat': 54.19573, 'lng': 9.091093 }, {'name':"Heiloo", 'lat': 52.6045778, 'lng': 4.7121983 }, {'name':"Heino", 'lat': 52.42734, 'lng': 6.22146 }, {'name':"Helmond", 'lat': 51.4805851, 'lng': 5.6537722 }, {'name':"Helmond 't Hout", 'lat': 51.4611277, 'lng': 5.6428328 }, {'name':"Helmond Brandevoort", 'lat': 51.455675, 'lng': 5.6201735 }, {'name':"Helmond Brouwhuis", 'lat': 51.4601521, 'lng': 5.7012308 }, {'name':"Hemmen Dodewaard", 'lat': 51.9098772, 'lng': 5.6559599 }, {'name':"Hengelo", 'lat': 52.2636963, 'lng': 6.7909148 }, {'name':"Hengelo Oost", 'lat': 52.26883, 'lng': 6.81923 }, {'name':"Hertogenb ('s) Oost", 'lat': 51.2887027, 'lng': 4.1946862 }, {'name':"Hertogenbosch ('s)", 'lat': 51.6900886, 'lng': 5.3036905 }, {'name':"Herzogenrath", 'lat': 50.8688041, 'lng': 6.0967109 }, {'name':"Hillegom", 'lat': 52.2916079, 'lng': 4.5786859 }, {'name':"Hilversum", 'lat': 52.2239905, 'lng': 5.1709992 }, {'name':"Hilversum Noord", 'lat': 52.23844, 'lng': 5.17365 }, {'name':"Hilversum Sportpark", 'lat': 52.21637, 'lng': 5.18778 }, {'name':"Hindeloopen", 'lat': 52.9426763, 'lng': 5.4010447 }, {'name':"Hoek van Holland Haven", 'lat': 51.97631, 'lng': 4.12754 }, {'name':"Hoek van Holland Strand", 'lat': 51.98193, 'lng': 4.11931 }, {'name':"Hoensbroek", 'lat': 50.9215351, 'lng': 5.9264935 }, {'name':"Hollandsche Rading", 'lat': 52.1763475, 'lng': 5.1803159 }, {'name':"Holten", 'lat': 52.307433, 'lng': 6.5216796 }, {'name':"Holtwick", 'lat': 51.998464, 'lng': 7.122652 }, {'name':"Holzwickede", 'lat': 51.501488, 'lng': 7.618124 }, {'name':"Hoofddorp", 'lat': 52.3087127, 'lng': 4.6872859 }, {'name':"Hoogeveen", 'lat': 52.7262076, 'lng': 6.4777592 }, {'name':"Hoogezand Sappemeer", 'lat': 53.1642117, 'lng': 6.7900491 }, {'name':"Hoogkarspel", 'lat': 52.6953813, 'lng': 5.177162 }, {'name':"Hoorn", 'lat': 52.6414583, 'lng': 5.0568067 }, {'name':"Hoorn Kersenboogerd", 'lat': 52.6532, 'lng': 5.08466 }, {'name':"Horst Sevenum", 'lat': 51.4120658, 'lng': 6.0369468 }, {'name':"Houten", 'lat': None, 'lng': None }, {'name':"Houten Castellum", 'lat': 52.0197222, 'lng': 5.1775 }, {'name':"Houthem St Gerlach", 'lat': 50.87349, 'lng': 5.79592 }, {'name':"Hurdegaryp", 'lat': 53.2179445, 'lng': 5.9460158 }, {'name':"Kaldenkirchen", 'lat': 51.3198403, 'lng': 6.1974389 }, {'name':"Kalmthout", 'lat': 51.3827717, 'lng': 4.4763136 }, {'name':"Kampen", 'lat': 52.5590431, 'lng': 5.9151231 }, {'name':"Kapelle Biezelinge", 'lat': 51.4748782, 'lng': 3.9652629 }, {'name':"Kapellen", 'lat': 51.3137593, 'lng': 4.4327932 }, {'name':"Karlsruhe Hbf", 'lat': 49.0080848, 'lng': 8.4037563 }, {'name':"Kerkrade Centrum", 'lat': 50.86111, 'lng': 6.05728 }, {'name':"Kesteren", 'lat': 51.9329686, 'lng': 5.5744896 }, {'name':"Keulen", 'lat': 50.9406645, 'lng': 6.9599115 }, {'name':"Klarenbeek", 'lat': 52.17804, 'lng': 6.08418 }, {'name':"Klimmen Ransdaal", 'lat': 50.883971, 'lng': 5.9306707 }, {'name':"Koblenz Hbf", 'lat': 50.356718, 'lng': 7.599485 }, {'name':"Koeln Deutz", 'lat': 50.9369996, 'lng': 6.977878 }, {'name':"Koeln Hbf", 'lat': 50.9406645, 'lng': 6.9599115 }, {'name':"Koeln Ehrenfeld", 'lat': 50.9456262, 'lng': 6.9205919 }, {'name':"Kohlscheid", 'lat': 50.8347902, 'lng': 6.0880776 }, {'name':"Koog Bloemwijk", 'lat': 52.45784, 'lng': 4.80564 }, {'name':"Koog Zaandijk", 'lat': 52.4720794, 'lng': 4.8092656 }, {'name':"Koudum Molkwerum", 'lat': 52.90288, 'lng': 5.41064 }, {'name':"Krabbendijke", 'lat': 51.43308, 'lng': 4.11725 }, {'name':"Krommenie Assendelft", 'lat': 52.442161, 'lng': 4.810628 }, {'name':"Kropswolde", 'lat': 53.1477757, 'lng': 6.7235415 }, {'name':"Kruiningen Yerseke", 'lat': 51.4217978, 'lng': 4.1181265 }, {'name':"Lage Zwaluwe", 'lat': 51.7046554, 'lng': 4.7076829 }, {'name':"Landgraaf", 'lat': 50.9077299, 'lng': 6.0284835 }, {'name':"Landry", 'lat': 29.8693722, 'lng': -91.6653928 }, {'name':"Leer (Ostfriesland)", 'lat': 53.230816, 'lng': 7.462341 }, {'name':"Leerdam", 'lat': 51.8918938, 'lng': 5.0903875 }, {'name':"Leeuwarden", 'lat': 53.2034077, 'lng': 5.7913076 }, {'name':"Leeuwarden Camminghaburen", 'lat': 53.2086111, 'lng': 5.8438889 }, {'name':"Legden", 'lat': 52.0308356, 'lng': 7.1041222 }, {'name':"Leiden", 'lat': 52.1610869, 'lng': 4.4901527 }, {'name':"Leiden Centraal", 'lat': 52.16653, 'lng': 4.48238 }, {'name':"Leiden Lammenschans", 'lat': 52.14691, 'lng': 4.49255 }, {'name':"Lelystad Centrum", 'lat': 52.50743, 'lng': 5.47277 }, {'name':"Lette (Kr Coesfeld)", 'lat': 51.892495, 'lng': 7.186998 }, {'name':"Lichtenvoorde Groenlo", 'lat': 52.0183644, 'lng': 6.5791873 }, {'name':"Liege Guillemins", 'lat': 50.6239963, 'lng': 5.5683231 }, {'name':"Lochem", 'lat': 52.161, 'lng': 6.4173689 }, {'name':"Loppersum", 'lat': 53.3317814, 'lng': 6.7470059 }, {'name':"Luedinghausen", 'lat': 51.7705351, 'lng': 7.4426488 }, {'name':"Luenen Hbf", 'lat': 51.616571, 'lng': 7.529459 }, {'name':"Lunteren", 'lat': 52.0840557, 'lng': 5.6209821 }, {'name':"Maarn", 'lat': 52.212037, 'lng': 5.2926822 }, {'name':"Maarssen", 'lat': 52.1390488, 'lng': 5.0396849 }, {'name':"Maassluis", 'lat': 51.9201973, 'lng': 4.2547026 }, {'name':"Maassluis West", 'lat': 51.92604, 'lng': 4.23575 }, {'name':"Maastricht", 'lat': 50.8498466, 'lng': 5.6872594 }, {'name':"Maastricht Randwyck", 'lat': 50.83784, 'lng': 5.71753 }, {'name':"Mainz Hbf", 'lat': 49.9951227, 'lng': 8.2674264 }, {'name':"Mannheim Hbf", 'lat': 49.4846773, 'lng': 8.476724 }, {'name':"Mantgum", 'lat': 53.1284166, 'lng': 5.7191113 }, {'name':"Marienberg", 'lat': 50.6510031, 'lng': 13.1648006 }, {'name':"Marne la Vallee Chessy", 'lat': 48.8682556, 'lng': 2.7821843 }, {'name':"Marseille St Charles", 'lat': 43.3025704, 'lng': 5.3799319 }, {'name':"Martenshoek", 'lat': 53.1631832, 'lng': 6.7429309 }, {'name':"Mechelen", 'lat': 51.028919, 'lng': 4.4780726 }, {'name':"Meerssen", 'lat': 52.1390488, 'lng': 5.0396849 }, {'name':"Meppel", 'lat': 52.7005906, 'lng': 6.1954831 }, {'name':"Metelen Land", 'lat': 52.162444, 'lng': 7.254423 }, {'name':"Middelburg", 'lat': 51.5014465, 'lng': 3.6148994 }, {'name':"Minden (Westf.)", 'lat': 52.289987, 'lng': 8.922157 }, {'name':"Moenchengladbach Hbf", 'lat': 51.191261, 'lng': 6.442066 }, {'name':"Mook Molenhoek", 'lat': 51.7677331, 'lng': 5.8726915 }, {'name':"Moutiers Salins Brides", 'lat': None, 'lng': None }, {'name':"Muenchen Hbf", 'lat': 48.140232, 'lng': 11.558335 }, {'name':"Muenster (W) Zentrum Nord", 'lat': 51.994704, 'lng': 7.623693 }, {'name':"Muenster (Westf) Hbf", 'lat': 51.956892, 'lng': 7.635895 }, {'name':"Muenster H�ger", 'lat': None, 'lng': None }, {'name':"Naarden Bussum", 'lat': 52.2738152, 'lng': 5.166596 }, {'name':"Neuss Hbf", 'lat': 51.204, 'lng': 6.684 }, {'name':"Nieuw Amsterdam", 'lat': 52.7156081, 'lng': 6.8557277 }, {'name':"Nieuw Vennep", 'lat': 52.2647514, 'lng': 4.6309378 }, {'name':"Nieuwerkerk ad IJssel", 'lat': 51.9365018, 'lng': 4.6329991 }, {'name':"Nieuweschans", 'lat': 53.1815806, 'lng': 7.2066459 }, {'name':"Nijkerk", 'lat': 52.2226621, 'lng': 5.4833629 }, {'name':"Nijmegen", 'lat': 51.8416922, 'lng': 5.858651 }, {'name':"Nijmegen Dukenburg", 'lat': 51.82395, 'lng': 5.79509 }, {'name':"Nijmegen Heyendaal", 'lat': 51.8311277, 'lng': 5.8693924 }, {'name':"Nijmegen Lent", 'lat': 51.8632959, 'lng': 5.865074 }, {'name':"Nijverdal", 'lat': 52.36571, 'lng': 6.47011 }, {'name':"Nijverdal West", 'lat': 52.36571, 'lng': 6.47011 }, {'name':"Nordwalde", 'lat': 52.0847235, 'lng': 7.480839 }, {'name':"Nunspeet", 'lat': 52.3760642, 'lng': 5.7841918 }, {'name':"Nuth", 'lat': 50.9178168, 'lng': 5.8847189 }, {'name':"Obdam", 'lat': 52.6749893, 'lng': 4.9063292 }, {'name':"Oberhausen Hbf", 'lat': 51.469612, 'lng': 6.8658829 }, {'name':"Ochtrup", 'lat': 52.210261, 'lng': 7.1887631 }, {'name':"Offenburg", 'lat': 48.467987, 'lng': 7.942387 }, {'name':"Oisterwijk", 'lat': 51.5808693, 'lng': 5.19803 }, {'name':"Oldenburg (oldb) Hbf", 'lat': 53.1367227, 'lng': 8.2165291 }, {'name':"Oldenzaal", 'lat': 52.3122017, 'lng': 6.9293126 }, {'name':"Olst", 'lat': 52.3878637, 'lng': 6.1355887 }, {'name':"Ommen", 'lat': 52.5190282, 'lng': 6.4239581 }, {'name':"Onze Lieve Vrouwe ter Nood", 'lat': 52.5838889, 'lng': 4.6905556 }, {'name':"Oosterbeek", 'lat': 51.9734101, 'lng': 5.7317678 }, {'name':"Opheusden", 'lat': 51.9337078, 'lng': 5.629784 }, {'name':"Osnabrueck Hbf", 'lat': 52.272191, 'lng': 8.061238 }, {'name':"Oss", 'lat': 51.7659215, 'lng': 5.5264639 }, {'name':"Oss West", 'lat': 51.7659215, 'lng': 5.5264639 }, {'name':"Oudenbosch", 'lat': 51.5887443, 'lng': 4.5281922 }, {'name':"Overveen", 'lat': 52.3914099, 'lng': 4.6095445 }, {'name':"Parijs", 'lat': 48.8566667, 'lng': 2.3509871 }, {'name':"Paris Nord", 'lat': 48.880931, 'lng': 2.355323 }, {'name':"Plochingen", 'lat': 48.709804, 'lng': 9.417295 }, {'name':"Preussen", 'lat': 51.588846, 'lng': 7.539309 }, {'name':"Pulheim", 'lat': 50.9988374, 'lng': 6.7981391 }, {'name':"Purmerend", 'lat': 52.5099351, 'lng': 4.9450182 }, {'name':"Purmerend Overwhere", 'lat': 52.51127, 'lng': 4.96773 }, {'name':"Purmerend Weidevenne", 'lat': 52.49663, 'lng': 4.93565 }, {'name':"Putten", 'lat': 52.2607099, 'lng': 5.6094217 }, {'name':"Raalte", 'lat': 52.3872957, 'lng': 6.2753989 }, {'name':"Ravenstein", 'lat': 49.4005079, 'lng': 9.5068587 }, {'name':"Reuver", 'lat': 51.2853933, 'lng': 6.0793114 }, {'name':"Rheden", 'lat': 52.00637, 'lng': 6.0341125 }, {'name':"Rheine", 'lat': 52.2765838, 'lng': 7.4384809 }, {'name':"Rhenen", 'lat': 51.9577345, 'lng': 5.5663059 }, {'name':"Rijssen", 'lat': 52.307433, 'lng': 6.5216796 }, {'name':"Rijswijk", 'lat': 52.0420486, 'lng': 4.3216539 }, {'name':"Rilland Bath", 'lat': 51.4166667, 'lng': 4.1833333 }, {'name':"Roermond", 'lat': 51.1927487, 'lng': 5.992726 }, {'name':"Rommerskirchen", 'lat': 51.033988, 'lng': 6.689963 }, {'name':"Roodeschool", 'lat': 53.4205115, 'lng': 6.7631446 }, {'name':"Roosendaal", 'lat': 51.5315691, 'lng': 4.459848 }, {'name':"Rosmalen", 'lat': 51.7171512, 'lng': 5.3624425 }, {'name':"Rotterdam", 'lat': 51.9226899, 'lng': 4.4707867 }, {'name':"Rotterdam Alexander", 'lat': 51.95117, 'lng': 4.55202 }, {'name':"Rotterdam Blaak", 'lat': 51.918866, 'lng': 4.4858766 }, {'name':"Rotterdam Centraal", 'lat': 51.92482, 'lng': 4.46899 }, {'name':"Rotterdam Lombardijen", 'lat': 51.8772222, 'lng': 4.5221111 }, {'name':"Rotterdam Noord", 'lat': 51.9358333, 'lng': 4.4777778 }, {'name':"Rotterdam Stadion", 'lat': 51.89578, 'lng': 4.52443 }, {'name':"Rotterdam Zuid", 'lat': 51.8883333, 'lng': 4.4952778 }, {'name':"Ruurlo", 'lat': 52.0864228, 'lng': 6.4494321 }, {'name':"Santpoort Noord", 'lat': 52.4331326, 'lng': 4.6433038 }, {'name':"Santpoort Zuid", 'lat': 52.4196458, 'lng': 4.6296508 }, {'name':"Sappemeer Oost", 'lat': 53.15891, 'lng': 6.79576 }, {'name':"Sauwerd", 'lat': 53.2944601, 'lng': 6.5330675 }, {'name':"Schagen", 'lat': 52.7882686, 'lng': 4.802157 }, {'name':"Scheemda", 'lat': 53.1763258, 'lng': 6.9723285 }, {'name':"Schiedam Centrum", 'lat': 51.92177, 'lng': 4.40929 }, {'name':"Schiedam Nieuwland", 'lat': 51.9202778, 'lng': 4.3863889 }, {'name':"Schin op Geul", 'lat': 50.8321829, 'lng': 5.8242324 }, {'name':"Schinnen", 'lat': 50.942438, 'lng': 5.8864557 }, {'name':"Schiphol", 'lat': 52.30907, 'lng': 4.7619 }, {'name':"Schwelm", 'lat': 51.28415, 'lng': 7.291389 }, {'name':"Schwerte (Ruhr)", 'lat': 51.4319465, 'lng': 7.3382799 }, {'name':"Selm", 'lat': 51.701427, 'lng': 7.468154 }, {'name':"Selm Beifang", 'lat': 51.6903119, 'lng': 7.4650063 }, {'name':"Siegburg", 'lat': 50.798766, 'lng': 7.208032 }, {'name':"Sittard", 'lat': 50.9686774, 'lng': 5.8249685 }, {'name':"Sliedrecht", 'lat': 51.8220505, 'lng': 4.7712901 }, {'name':"Sneek", 'lat': 53.0337195, 'lng': 5.6611342 }, {'name':"Sneek Noord", 'lat': 53.04058, 'lng': 5.66301 }, {'name':"Soest", 'lat': 51.570053, 'lng': 8.108287 }, {'name':"Soest Zuid", 'lat': 52.16521, 'lng': 5.30299 }, {'name':"Soestdijk", 'lat': 52.1877763, 'lng': 5.2850236 }, {'name':"Spaubeek", 'lat': 50.9381944, 'lng': 5.8403884 }, {'name':"Spoorwegmuseum", 'lat': 52.0881946, 'lng': 5.1305998 }, {'name':"Stavoren", 'lat': 52.8856861, 'lng': 5.3589022 }, {'name':"Stedum", 'lat': 52.269042, 'lng': 10.112875 }, {'name':"Steenwijk", 'lat': 52.7864896, 'lng': 6.1163592 }, {'name':"Stendal", 'lat': 52.604071, 'lng': 11.866368 }, {'name':"Stolberg Altstadt", 'lat': 51.964402, 'lng': 7.640012 }, {'name':"Stolberg Hbf", 'lat': 50.7947222, 'lng': 6.2194444 }, {'name':"Stommeln", 'lat': 51.0181284, 'lng': 6.752429 }, {'name':"Stuttgart Hbf", 'lat': 48.7771056, 'lng': 9.1807688 }, {'name':"Susteren", 'lat': 51.06073, 'lng': 5.86265 }, {'name':"Swalmen", 'lat': 51.2322192, 'lng': 6.0381083 }, {'name':"Szczecin Glowny", 'lat': 53.4188889, 'lng': 14.5508333 }, {'name':"Szczecin Gumience", 'lat': 53.4160342, 'lng': 14.486171 }, {'name':"Tegelen", 'lat': 51.342702, 'lng': 6.1370261 }, {'name':"Terborg", 'lat': 51.9195937, 'lng': 6.3597972 }, {'name':"Tiel", 'lat': 51.887151, 'lng': 5.4371157 }, {'name':"Tiel Passewaaij", 'lat': 51.8707467, 'lng': 5.3994011 }, {'name':"Tilburg", 'lat': 51.5552442, 'lng': 5.0906503 }, {'name':"Tilburg Reeshof", 'lat': 51.5766667, 'lng': 4.9944444 }, {'name':"Tilburg West", 'lat': 51.58399, 'lng': 4.9246 }, {'name':"Twello", 'lat': 52.237075, 'lng': 6.1032772 }, {'name':"Uitgeest", 'lat': 52.5301405, 'lng': 4.7092073 }, {'name':"Uithuizen", 'lat': 53.4075058, 'lng': 6.673143 }, {'name':"Uithuizermeeden", 'lat': 53.4131675, 'lng': 6.7229502 }, {'name':"Ulm Hbf", 'lat': 48.399015, 'lng': 9.982165 }, {'name':"Unna", 'lat': 51.534471, 'lng': 7.685883 }, {'name':"Usquert", 'lat': 53.4031466, 'lng': 6.6131946 }, {'name':"Utrecht", 'lat': 52.0912623, 'lng': 5.1227478 }, {'name':"Utrecht Centraal", 'lat': 52.0896, 'lng': 5.11041 }, {'name':"Utrecht Lunetten", 'lat': 52.0625971, 'lng': 5.1323002 }, {'name':"Utrecht Maliebaan", 'lat': 52.091871, 'lng': 5.1338639 }, {'name':"Utrecht Overvecht", 'lat': 52.11024, 'lng': 5.12535 }, {'name':"Utrecht Terwijde", 'lat': 52.0912623, 'lng': 5.1227478 }, {'name':"Utrecht Zuilen", 'lat': 52.0912623, 'lng': 5.1227478 }, {'name':"Valence TGV", 'lat': 44.9916667, 'lng': 4.9786111 }, {'name':"Valkenburg", 'lat': 50.8626123, 'lng': 5.830137 }, {'name':"Varsseveld", 'lat': 51.9422985, 'lng': 6.4613929 }, {'name':"Veenendaal Centrum", 'lat': 52.02595, 'lng': 5.55787 }, {'name':"Veenendaal West", 'lat': 52.0251348, 'lng': 5.5591745 }, {'name':"Veenendaal De Klomp", 'lat': 52.0480264, 'lng': 5.5725304 }, {'name':"Veenwouden", 'lat': 53.2418131, 'lng': 5.9938729 }, {'name':"Velp", 'lat': 51.9953, 'lng': 5.98095 }, {'name':"Venlo", 'lat': 51.36493, 'lng': 6.17123 }, {'name':"Venray", 'lat': 51.529032, 'lng': 5.9741915 }, {'name':"Vierlingsbeek", 'lat': 51.597066, 'lng': 6.0125626 }, {'name':"Viersen", 'lat': 51.255706, 'lng': 6.398319 }, {'name':"Vise", 'lat': 50.7331465, 'lng': 5.6964905 }, {'name':"Vlaardingen Centrum", 'lat': 51.97709, 'lng': 4.31558 }, {'name':"Vlaardingen Oost", 'lat': 51.91032, 'lng': 4.36148 }, {'name':"Vlaardingen West", 'lat': 51.9098742, 'lng': 4.3419964 }, {'name':"Vleuten", 'lat': 52.1068245, 'lng': 5.0106074 }, {'name':"Vlissingen", 'lat': 51.4556773, 'lng': 3.576488 }, {'name':"Vlissingen Souburg", 'lat': 51.464184, 'lng': 3.6051278 }, {'name':"Voerendaal", 'lat': 50.883971, 'lng': 5.9306707 }, {'name':"Voorburg", 'lat': 52.0788786, 'lng': 4.4003218 }, {'name':"Voorhout", 'lat': 52.22462, 'lng': 4.48414 }, {'name':"Voorschoten", 'lat': 52.1270397, 'lng': 4.4464111 }, {'name':"Voorst Empe", 'lat': 52.1554488, 'lng': 6.1406897 }, {'name':"Vorden", 'lat': 38.2771359, 'lng': -121.5410649 }, {'name':"Vriezenveen", 'lat': 52.4125088, 'lng': 6.6257332 }, {'name':"Vroomshoop", 'lat': 52.4604807, 'lng': 6.5710841 }, {'name':"Vught", 'lat': 51.6584499, 'lng': 5.2985422 }, {'name':"Waddinxveen", 'lat': 52.045578, 'lng': 4.645496 }, {'name':"Waddinxveen Noord", 'lat': 52.05562, 'lng': 4.64829 }, {'name':"Warffum", 'lat': 53.39038, 'lng': 6.56694 }, {'name':"Weener", 'lat': 53.165977, 'lng': 7.353811 }, {'name':"Weert", 'lat': 51.2520178, 'lng': 5.710258 }, {'name':"Weesp", 'lat': 52.3073257, 'lng': 5.0426099 }, {'name':"Wehl", 'lat': 51.95703, 'lng': 6.21299 }, {'name':"Wezep", 'lat': 52.4606073, 'lng': 5.9981482 }, {'name':"Wien Westbf", 'lat': 48.197113, 'lng': 16.337118 }, {'name':"Wierden", 'lat': 52.3579118, 'lng': 6.5922011 }, {'name':"Wijchen", 'lat': 51.8077488, 'lng': 5.727594 }, {'name':"Wijhe", 'lat': 52.3878637, 'lng': 6.1355887 }, {'name':"Winschoten", 'lat': 53.1431565, 'lng': 7.0398484 }, {'name':"Winsum", 'lat': 53.3314477, 'lng': 6.5157 }, {'name':"Winterswijk", 'lat': 51.9720177, 'lng': 6.7201294 }, {'name':"Winterswijk West", 'lat': 51.9720177, 'lng': 6.7201294 }, {'name':"Woerden", 'lat': 52.0860665, 'lng': 4.8839332 }, {'name':"Wolfheze", 'lat': None, 'lng': None }, {'name':"Wolfsburg", 'lat': 52.4218204, 'lng': 10.7849799 }, {'name':"Wolvega", 'lat': 52.8772988, 'lng': 6.005167 }, {'name':"Workum", 'lat': 52.9790945, 'lng': 5.4432587 }, {'name':"Wormerveer", 'lat': 52.4940451, 'lng': 4.7876586 }, {'name':"Wuppertal Hbf", 'lat': 51.255871, 'lng': 7.149985 }, {'name':"Wuppertal Oberbarmen", 'lat': 51.285051, 'lng': 7.226425 }, {'name':"Wuppertal Barmen", 'lat': 51.270651, 'lng': 7.1945641 }, {'name':"Zaandam", 'lat': 52.4386676, 'lng': 4.8254838 }, {'name':"Zaandam Kogerveld", 'lat': 52.4585418, 'lng': 4.8315313 }, {'name':"Zaltbommel", 'lat': 51.813575, 'lng': 5.2479086 }, {'name':"Zandvoort aan Zee", 'lat': 52.395, 'lng': 4.5377778 }, {'name':"Zetten Andelst", 'lat': 51.9198, 'lng': 5.72281 }, {'name':"Zevenaar", 'lat': 51.9281412, 'lng': 6.0764324 }, {'name':"Zevenbergen", 'lat': 51.6440634, 'lng': 4.5998008 }, {'name':"Zoetermeer", 'lat': 52.0604993, 'lng': 4.4933069 }, {'name':"Zoetermeer Oost", 'lat': 52.0449794, 'lng': 4.5090293 }, {'name':"Zuerich HB", 'lat': 47.3781866, 'lng': 8.5401909 }, {'name':"Zuidbroek", 'lat': 52.24203, 'lng': 5.9971 }, {'name':"Zuidhorn", 'lat': 53.2442716, 'lng': 6.4074457 }, {'name':"Zutphen", 'lat': 52.141405, 'lng': 6.1953058 }, {'name':"Zwaagwesteinde", 'lat': 53.2532926, 'lng': 6.0367878 }, {'name':"Zwijndrecht", 'lat': 51.81556, 'lng': 4.64089 }, {'name':"Zwolle", 'lat': 52.50518, 'lng': 6.09108 }]

class LocationService:
    def __init__(self, callback=None):
        self.control = location.GPSDControl.get_default()
        self.device = location.GPSDevice()
        self.control.set_properties(preferred_method=location.METHOD_USER_SELECTED,
                               preferred_interval=location.INTERVAL_DEFAULT)
        
        self.control.connect("error-verbose", self.on_error)
        self.device.connect("changed", self.on_changed, self.control)
        self.control.connect("gpsd-stopped", self.on_stop)
        
        self.lat = None
        self.lng = None
        self.closestStation = {'name': '', 'lat': None, 'lng': None}
        self.callback= callback
                

    def on_error(self, control, error, data):
        print "GPS Error"
        data.quit()
    
    def on_changed(self, device, data):
        if not device:
            return
        if device.fix:
            if device.fix[1] & location.GPS_DEVICE_LATLONG_SET:
                    self.lat = device.fix[4]
                    self.lng = device.fix[5]
                         
                    self.stop_location(data)
                    
                    min = 100000
                    for station in stations:
                        try:
                            d = location.distance_between(self.lat, self.lng, station['lat'], station['lng'])
                        except TypeError:
                            # no data from the station, just skip
                            pass
                        if d < min:
                            min = d
                            self.closestStation = station
                        
            if self.callback:
                self.callback()
            else:
                print self.lat,self.lng,self.closestStation['name']
                        
    
    def on_stop(control, data):
        pass
    
    def start_location(self, data):
        data.start()
        return False
    
    def stop_location(self, data):
        data.stop()
        return False
        
if __name__ == "__main__":    
    import gobject    
    l = LocationService()
    l.start_location(l.control)
    loop = gobject.MainLoop()

    loop.run()
